%ifarch x86_64
%define	wine	wine64
%define	mark64	()(64bit)
%else
%define	wine	wine
%define	mark64	%{nil}
%endif
%define	lib_name_orig	lib%{name}
%define	lib_major	1
%define	lib_name	%mklibname %{name} %{lib_major}
%define	lib_name_devel	%{mklibname -d wine}

%define gecko_version	2.47.4
%define mono_version	8.1.0
%define o_ver	%{version}

Name:		wine
Version:	9.0
Release:	%mkrel 3
Summary:	WINE Is Not An Emulator - runs MS Windows programs
License:	LGPLv2+
Group:		Emulators
URL:		http://www.winehq.com/
Source0:	https://deac-ams.dl.sourceforge.net/project/wine/Source/%{name}-%{o_ver}.tar.xz
Source2:    wine.init
Source3:	%{name}-icons_256.tar.xz
Source10: wine-notepad.desktop
Source11: wine-regedit.desktop
Source12: wine-wine64_oleview.desktop
Source13: wine-wine64_uninstaller.desktop
Source14: wine-wine64_winhlp32.desktop
Source15: wine-wine64_wordpad.desktop
Source16: wine-wineboot.desktop
Source17: wine-winecfg.desktop
Source18: wine-wineconsole_cmd.desktop
Source19: wine-winefile.desktop
Source29: wine-winemine.desktop
Patch101: server.c.diff

#----------------------------------------------------
BuildRequires:  autoconf
BuildRequires:  bison
BuildRequires:  chrpath
BuildRequires:  cups-devel
BuildRequires:  dbus-devel
BuildRequires:  desktop-file-utils
BuildRequires:  docbook-dtd-sgml
BuildRequires:  docbook-utils
BuildRequires:  ffmpeg-devel
BuildRequires:  flex
BuildRequires:  fontconfig-devel
BuildRequires:  fontforge-devel
BuildRequires:  freetype2-devel
BuildRequires:  gettext-devel
BuildRequires:  glibc-static-devel
BuildRequires:  gnutls-devel
BuildRequires:  gphoto2-devel
BuildRequires:  gpm-devel
BuildRequires:  gstreamer1.0-devel
BuildRequires:  gtk3-devel
BuildRequires:  icoutils
BuildRequires:  imagemagick
BuildConflicts:  isdn4k-utils-devel
BuildRequires:  lcms2-devel
BuildRequires:  libalsa-devel
BuildRequires:  libgstreamer1.0-plugins-base-devel
BuildRequires:  libmpg123-devel
BuildRequires:  libpcap-devel
BuildRequires:  librsvg
BuildRequires:  libsm-devel
BuildRequires:  libx11-devel
BuildRequires:  libxcomposite-devel
BuildRequires:  libxcursor-devel
BuildRequires:  libxext-devel
BuildRequires:  libxi-devel
BuildRequires:  libxinerama-devel
BuildRequires:  libxrandr-devel
BuildRequires:  libxrender-devel
BuildRequires:  libxslt-devel
BuildRequires:  ncurses-devel
BuildRequires:  openal-devel
BuildRequires:  openldap-devel
BuildRequires:  mesa-devel
BuildRequires:  perl-devel
BuildRequires:  png-devel
BuildRequires:  pulseaudio-devel
BuildRequires:  sane-devel
BuildRequires:  tiff-devel
BuildRequires:  ungif-devel
BuildRequires:  unixODBC-devel
BuildRequires:  xpm-devel
BuildRequires:  %{_lib}vkd3d-devel
BuildRequires:  %{_lib}vulkan-loader-devel
BuildRequires:  %{_lib}samba-devel
BuildRequires:  %{_lib}pcsclite-devel
#----------------------------------------------------
Requires:  asound
Requires:  crypto
Requires:  cups
Requires:  dbus-1
Requires:  fontconfig
Requires:  freetype
Requires:  gnutls
Requires:  gsm
Requires:  jpeg
Requires:  ncurses
Requires:  odbc
Requires:  mesa
Requires:  png
Requires:  sane
Requires:  ssl
Requires:  tiff
Requires:  v4l1
Requires:  Xcomposite
Requires:  Xcursor
Requires:  Xinerama
Requires:  Xrandr
Requires:  Xrender
Requires:  xslt
Requires:  Xxf86vm
#----------------------------------------------------


%define desc Wine is a program which allows running Microsoft Windows programs \
(including DOS, Windows 3.x and Win32 executables) on Unix. It \
consists of a program loader which loads and executes a Microsoft \
Windows binary, and a library (called Winelib) that implements Windows \
API calls using their Unix or X11 equivalents.  The library may also \
be used for porting Win32 code into native Unix executables.

%ifarch x86_64
%package -n	%{wine}
Summary:	WINE Is Not An Emulator - runs MS Windows programs
Group:		Emulators
Obsoletes: 	wine-wow64
Obsoletes:	wine < %{version}-%{release}
Provides:	wine = %{version}-%{release}
Requires:   wine32
Requires:   wine-mono
Requires:   wine-gecko
Requires:   libvulkan.so.1()(64bit)

%endif

Obsoletes: 	%name < %version
Provides:	%{wine}-utils = %{version}-%{release} %{wine}-full = %{version}-%{release}
Provides:	%{lib_name}-capi = %{version}-%{release} %{lib_name}-twain = %{version}-%{release}
Provides:	%{lib_name} = %{version}-%{release}
Provides:	wine-bin = %{version}-%{release}
Obsoletes:	%{wine}-utils %{wine}-full %{lib_name}-capi %{lib_name}-twain %{lib_name}
Requires:	xmessage
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
Requires(post): desktop-common-data
Requires(postun): desktop-common-data
Requires(preun): rpm-helper
Requires(post):	rpm-helper
%ifarch %{ix86}
Conflicts:	wine64
%endif

%description
%desc

%ifarch x86_64
%description -n	%{wine}
%desc
This package contains the Win64 version of Wine.
%endif


%ifarch %ix86
%package -n	wine32
Summary:	32-bit support for Wine
Group:		Emulators
Requires:	wine-bin
Requires:   ia32-libs
Provides:	libwine.so.1

%description -n	wine32
Wine is a program which allows running Microsoft Windows programs
(including DOS, Windows 3.x and Win32 executables) on Unix.

This package contains the files needed to support 32-bit Windows
programs.
%endif

%package -n	%{wine}-devel
Summary:	Static libraries and headers for %{name}
Group:		Development/Libraries
Requires:	%{wine} = %{version}
Provides:	%{lib_name_devel} = %{version}-%{release}
Provides:	%{lib_name_orig}-devel = %{version}-%{release}
Obsoletes:	%{lib_name_devel} <= %{version}-%{release}
Obsoletes:	%{mklibname -d wine 1}
%ifarch %{ix86}
Conflicts:	wine64-devel
%else
Conflicts:	wine-devel
%endif

%description -n	%{wine}-devel
Wine is a program which allows running Microsoft Windows programs
(including DOS, Windows 3.x and Win32 executables) on Unix.

%{wine}-devel contains the libraries and header files needed to
develop programs which make use of wine.

Wine is often updated.

%prep
%setup -q -n %name-%o_ver

%patch101 -p1 -b .conf

GECKO_VERSION=$(sed -rn 's,^#define\s+GECKO_VERSION\s+"([^"]*)".*$,\1,p' dlls/appwiz.cpl/addons.c)
[ "$GECKO_VERSION" = "%gecko_version" ] || { echo %{name}-gecko version mismatch; exit 1; }
MONO_VERSION=$(sed -rn 's,^#define\s+MONO_VERSION\s+"([^"]*)".*$,\1,p' dlls/appwiz.cpl/addons.c)
[ "$MONO_VERSION" = "%mono_version" ] || { echo wine-mono version mismatch; exit 1; }

%build
autoreconf -fiv
aclocal
autoconf
# mesa is now with glvnd=true
export LDFLAGS="-L/usr/lib64/libglvnd/ $LDFLAGS"
# disable fortify as it breaks wine
%define _fortify_cflags %nil
%ifarch %{ix86}
# (Anssi 04/2008) bug #39604
# Some protection systems complain "debugger detected" with our
# -fomit-frame-pointer flag, so disable it.
export CFLAGS="${CFLAGS} -fno-omit-frame-pointer"
%endif
%ifarch %{x86_64}
# As of wine 6.0, clang 12.0:
# winecfg in 64bit mode crashes on startup if built with
# clang. Probably clang doesn't get the M$ ABI right
export CC=gcc
export CXX=g++
%endif

%configure2_5x	--with-x \
		--with-pulse \
		--with-dbus \
		--without-capi \
		--without-mingw \
		--without-oss \
		--with-gstreamer \
%ifarch x86_64
		--enable-win64
%endif

%make depend
%make


%install
rm -rf %{buildroot}
%makeinstall_std LDCONFIG=/bin/true 

#install -m755 tools/fnt2fon -D %{buildroot}%{_bindir}/fnt2fon

# Allow users to launch Windows programs by just clicking on the .exe file...
install -m755 %{SOURCE2} -D %{buildroot}%{_initrddir}/%{name}

mkdir -p %{buildroot}%{_iconsdir}/hicolor/256x256/apps
tar -Jxf %{SOURCE3} -C %{buildroot}%{_iconsdir}/hicolor/256x256/apps/

#menu entry for builtin applications that come with wine
mkdir -p %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE10 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE11 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE12 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE13 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE14 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE15 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE16 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE17 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE18 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE19 %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE29 %{buildroot}%{_datadir}/applications
#install -m 0644 %SOURCE21 %{buildroot}%{_datadir}/applications


install -d %{buildroot}{%{_liconsdir},%{_iconsdir},%{_miconsdir}}
convert dlls/user32/resources/oic_winlogo.ico[8] %{buildroot}%{_miconsdir}/%{name}.png
convert dlls/user32/resources/oic_winlogo.ico[7] %{buildroot}%{_iconsdir}/%{name}.png
convert dlls/user32/resources/oic_winlogo.ico[6] %{buildroot}%{_liconsdir}/%{name}.png


%ifarch x86_64
sed -i 's,Exec=wine ,Exec=wine64 ,' %{buildroot}%{_datadir}/applications/wine.desktop
%endif

%ifarch x86_64
chrpath -d %{buildroot}%{_bindir}/{wine64,wineserver,wmc,wrc}
%else
chrpath -d %{buildroot}%{_bindir}/{wine,wineserver,wmc,wrc}
%endif


%clean
rm -fr %{buildroot}

%preun -n %{wine}
%_preun_service %{name}


%post -n %{wine}
%_post_service %{name}
/sbin/ldconfig

%postun -n %{wine}
/sbin/ldconfig

%files -n %{wine}
%doc AUTHORS
%ifarch x86_64
%{_bindir}/%{name}64
%{_bindir}/%{name}64-preloader
%endif
%{_initrddir}/%{name}
%{_bindir}/winecfg
%{_bindir}/wineconsole*
%{_bindir}/wineserver
%{_bindir}/wineboot
%{_bindir}/function_grep.pl
%{_bindir}/msiexec
%{_bindir}/notepad
%{_bindir}/regedit
%{_bindir}/winemine
%{_bindir}/winepath
%{_bindir}/regsvr32
%{_bindir}/winefile
%ifnarch x86_64
%{_mandir}/man?/%{name}.?*
%lang(de) %{_mandir}/de.UTF-8/man?/%{name}.?*
%lang(fr) %{_mandir}/fr.UTF-8/man?/%{name}.?*
%lang(pl) %{_mandir}/pl.UTF-8/man?/%{name}.?*
%endif
%lang(de) %{_mandir}/de.UTF-8/man?/wineserver.?*
%lang(fr) %{_mandir}/fr.UTF-8/man?/wineserver.?*
%{_mandir}/man?/wineserver.?*
%{_mandir}/man?/msiexec.?*
%{_mandir}/man?/notepad.?*
%{_mandir}/man?/regedit.?*
%{_mandir}/man?/regsvr32.?*
%{_mandir}/man?/wineboot.?*
%{_mandir}/man?/winecfg.?*
%{_mandir}/man?/wineconsole.?*
%{_mandir}/man?/winefile.?*
%{_mandir}/man?/winemine.?*
%{_mandir}/man?/winepath.?*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.inf
%{_datadir}/%{name}/nls
%{_datadir}/applications/*.desktop
%dir %{_datadir}/wine/fonts
%{_datadir}/wine/fonts/*
%{_iconsdir}/hicolor/*/apps/*.png
%{_miconsdir}/%{name}.png
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%ifnarch x86_64
%files -n wine32
%{_bindir}/wine
%ifarch %{ix86}
%{_bindir}/wine-preloader
%endif
%{_mandir}/man?/%{name}.?*
%lang(de) %{_mandir}/de.UTF-8/man?/%{name}.?*
%lang(fr) %{_mandir}/fr.UTF-8/man?/%{name}.?*
%lang(pl) %{_mandir}/pl.UTF-8/man?/%{name}.?*
%endif
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/*-windows
%{_libdir}/%{name}/*-windows/*.[b-z]*
%{_libdir}/%{name}/*-windows/*.a[a-z]*
%dir %{_libdir}/%{name}/*-unix
%{_libdir}/%{name}/*-unix/*.so*

%files -n %{wine}-devel
%{_libdir}/%{name}/*-unix/*.a
%{_includedir}/*
%{_bindir}/msidb
%{_bindir}/wmc
%{_bindir}/wrc
%{_bindir}/winebuild
%{_bindir}/winegcc
%{_bindir}/wineg++
%{_bindir}/winecpp
%{_bindir}/widl
%{_bindir}/winedbg
%{_bindir}/winemaker
%{_bindir}/winedump
%lang(de) %{_mandir}/de.UTF-8/man?/winemaker.?*
%lang(fr) %{_mandir}/fr.UTF-8/man?/winemaker.?*
%{_mandir}/man1/wmc.1*
%{_mandir}/man1/wrc.1*
%{_mandir}/man1/winebuild.1*
%{_mandir}/man1/winemaker.1*
%{_mandir}/man1/winedump.1*
%{_mandir}/man1/widl.1*
%{_mandir}/man1/winedbg.1*
%{_mandir}/man1/wineg++.1*
%{_mandir}/man1/winegcc.1*
%{_mandir}/man1/winecpp.1*

%changelog
* Tue Feb 20 2024 tex - 9.0-3pclos2024
- add BR  fontforge-devel

* Wed Feb 14 2024 yodelu - 9.0-2pclos2024
- fixes only for x32 package of wine (x64 not affected)
	> fix build of wayland layer
		> provide propper libs in ia32-libs package

* Wed Jan 17 2024 yodelu - 9.0-1pclos2024
- update to stable 9.0

* Thu Jul 20 2023 yodelu - 8.0.2-1pclos2023
- update to stable 8.0.2

